ACCOUNTLOGIN_FADEIN_TIME1 	= 1.0;
ACCOUNTLOGIN_FADEIN_TIME2 	= 1.5;
ACCOUNTLOGIN_AGREEMENT 		= 1;

LOGIN_FLASH_MAX_ALPHA = 1.2;
LOGIN_FLASH_MIN_ALPHA = 0.3;

function AccountLogin_OnShow()
	local hideLoginUI = false;
	
	if ( IsHideLoginUI and IsHideLoginUI() ) then
		hideLoginUI = true;
	elseif ( GetLocation() == "JP" or GetLocation() == "HG" or GetLocation() == "SG" ) then
		hideLoginUI = true;
	end

	if ( hideLoginUI ) then
		AccountLoginAccountEdit:Hide();
		AccountLoginPasswordEdit:Hide();
		AccountLastAccountButton:Hide();
		AccountLoginLoginButton:Hide();
	end

	if ( hideLoginUI and GetLocation() ~= "TW" ) then
		UserAgreement:Hide();
		AcceptUserAgreement();
		if ( ACCOUNTLOGIN_AGREEMENT ) then
			ACCOUNTLOGIN_AGREEMENT = nil;
			AccountLoginShow();
		end
	end

	if ( ACCOUNTLOGIN_AGREEMENT ) then
		ACCOUNTLOGIN_AGREEMENT = nil;
		AccountLogin:Hide();
		UserAgreement:Show();
	else
		AccountLoginAccountEdit:SetFocus();
	end
end

function AccountLogin_OnKeyDown(this, key)
	if ( key == "ESCAPE" ) then
		AccountLogin_Exit();
	end
end

function AccountLogin_OnKeyUp(this, key)

end

function AccountLogin_OnMouseDown(this, key)

end

function AccountLogin_OnMouseUp(this, key)

end

function AccountLogin_OnUpdate(this, elapsedTime)
	if ( AccountLogin.update ) then
		AccountLogin.update = AccountLogin.update + elapsedTime;
		Alpha = ( AccountLogin.update - ACCOUNTLOGIN_FADEIN_TIME1 ) / ACCOUNTLOGIN_FADEIN_TIME2;
		if( Alpha < 0 )then
			Alpha = 0;
		elseif( Alpha > 1.0 )then
			Alpha = 1.0;
		end
		AccountLogin:SetAlpha( Alpha );

		if ( Alpha >= 1.0 ) then
			AccountLogin.update = nil;
		end
	end
end

function AccountLogin_Login()
	DefaultServerLogin(AccountLoginAccountEdit:GetText(), AccountLoginPasswordEdit:GetText());
	AccountLoginPasswordEdit:SetText("");
	AccountLoginAccountEdit:ClearFocus();
	AccountLoginPasswordEdit:ClearFocus();
end

function AccountLogin_FocusPassword()
	AccountLoginPasswordEdit:SetFocus();
end

function AccountLogin_FocusAccountName()
	AccountLoginAccountEdit:SetFocus();
end

function AccountLoginPasswordEdit_OnGained(this, arg1)
	
end

function AccountLoginPasswordEdit_SetText(text)
	AccountLoginPasswordEdit:InsertChar(text);
end

function AccountLogin_Exit()
	QuitGame();
end

--[[function LoginFlashFrame_OnUpdate(this, elapsedTime)
	if ( this.alphaValue == nil ) then
		this.alphaValue = 0;
	end

	if ( this.state ) then
		this.alphaValue = this.alphaValue - elapsedTime;
		if ( this.alphaValue < LOGIN_FLASH_MIN_ALPHA ) then
			this.alphaValue = LOGIN_FLASH_MIN_ALPHA;
			this.state = nil;
		end
	else
		this.alphaValue = this.alphaValue + elapsedTime;
		if ( this.alphaValue > LOGIN_FLASH_MAX_ALPHA ) then
			this.alphaValue = LOGIN_FLASH_MAX_ALPHA;
			this.state = 1;
		end
	end
	this:SetAlpha(this.alphaValue);
end]]

function AccountLogin_OnLoad()
	local imageLocation = GetImageLocation("LOGO");
	local file = "Interface\\Login\\Logo\\"..imageLocation.."\\RA_LOGO";
	AccountLogin.update = nil;
	AccountLoginVersion:SetText(GetVersion());
	AccountLoginLogo:SetTexture(file);
end

function AccountLogin_Show()
	AccountLogin.update = 0;
	AccountLogin:SetAlpha(0);
	AccountLogin:Show();
end

function AccountLoginBoard_OnLoad(this)
	this:RegisterEvent("SERVER_BOARD_UPDATE");
end

function AccountLoginBoard_OnEvent(this, event)
	if ( event == "SERVER_BOARD_UPDATE" ) then
		AccountLoginBoardText:SetText(GetServerBoardText());
		AccountLoginBoardScrollFrame:UpdateScrollChildRect();
		AccountLoginBoard:Show();
	end
end

function CompanyLogo_OnLoad(this)
	this.updateTime = 2;
	this.runewakerTime = 3;

	local imageLocation = GetImageLocation("LOGO");
	CompanyLogoTexture:SetTexture("Interface\\Login\\Logo\\"..imageLocation.."\\RunewakerLogo");
end

function CompanyLogo_OnUpdate(this, elapsedTime)
	local updateTime = math.min(elapsedTime, 1);

	if ( this.runewakerTime ) then
		this.runewakerTime = this.runewakerTime - updateTime;
		if ( this.runewakerTime < 0 ) then
			this.runewakerTime = nil;
		end
	elseif ( this.updateTime ) then
		this.updateTime = this.updateTime - updateTime;
		if ( this.updateTime < 0 ) then
			this.updateTime = nil;
			this.fadeout = 1;
		end
	elseif ( this.fadeout ) then
		this.fadeout = this.fadeout - updateTime;
		this:SetAlpha(this.fadeout);
		if ( this.fadeout < 0 ) then
			this.fadeout = nil;
			this:Hide();
			--SetLoginScreen("login");
		end
	end
end

function UserAgreement_OnShow()
	if ( GetLocation() == "KR" ) then
		LoginKoreanImage15:Show();
		LoginKoreanImage18:Show();
		LoginKoreanImageVoilence:Show();
	else
		LoginKoreanImage15:Hide();
		LoginKoreanImage18:Hide();
		LoginKoreanImageVoilence:Hide();
	end	
end

function UserAgreement_OnHide()
	LoginKoreanImage15:Hide();
	LoginKoreanImage18:Hide();
	LoginKoreanImageVoilence:Hide();
end

function VivoxUserAgreement_OnLoad(this)	
	this:RegisterEvent("VIVOX_PACT");
end

function VivoxUserAgreement_Show(this)
	VivoxUserAgreementText:SetText(GetVivoxUserAgreementText());
	VivoxUserAgreementScrollFrame:UpdateScrollChildRect();
	VivoxUserAgreementOkayButton:Disable();
	VivoxUserAgreementCancelButton:Disable();	

	local scrollFrame = getglobal(this:GetName().."ScrollFrame");
	local scrollbar = getglobal(scrollFrame:GetName().."ScrollBar");
	scrollbar:SetValue(0);
	local min, max = scrollbar:GetMinMaxValues();
	if ((scrollbar:GetValue() - max) == 0) then
		VivoxUserAgreement_ReadFinish();
	end
	this:Show();
end

function VivocUserAgreement_OnEvent(this, event)
	if ( event == "VIVOX_PACT" ) then
		if ( not VivoxUserAgreement:IsVisible() ) then
			VivoxUserAgreement_Show(this);
		end
	end
end

function VivoxUserAgreement_ReadFinish()
	VivoxUserAgreementOkayButton:Enable();
	VivoxUserAgreementCancelButton:Enable();
end