LOGIN_SCROLLBUTTON_SCROLL_DELAY = 0.05;

function LoginButtonTemplate_OnLoad(this)
	this._SetText = this.SetText;
	this.SetText = function (this, text)
		this:_SetText("");
		this:_SetText(text);

		local width = this:GetWidth();
		local textWidth = this:GetTextWidth();
		if ( textWidth > width - 8 ) then
			this:GetNormalText():SetWidth(width - 8);
			this:GetDisabledText():SetWidth(width - 8);
			this:GetHighlightText():SetWidth(width - 8);

			this.tooltip = text;
		else
			this.tooltip = nil;
		end
	end
	this:SetText(this:GetText());
end

function LoginScrollUpButton_OnMouseDown(this)
	local slider = this:GetParent();
	local step = slider.stepRange or 1;
	slider:SetValue(slider:GetValue() - step);
	this.downDelay = LOGIN_SCROLLBUTTON_SCROLL_DELAY * 10;
end

function LoginScrollUpButton_OnUpdate(this, elapsed)
	if ( this:IsButtonPushed("LeftButton") and this.downDelay ) then
		this.downDelay = this.downDelay - elapsed;
		if ( this.downDelay < 0 ) then
			local slider = this:GetParent();
			local step = slider.stepRange or 1;
			slider:SetValue(slider:GetValue() - step);
			this.downDelay = LOGIN_SCROLLBUTTON_SCROLL_DELAY;
		end
	end
end

function LoginScrollDownButton_OnMouseDown(this)
	local slider = this:GetParent();
	local step = slider.stepRange or 1;
	slider:SetValue(slider:GetValue() + step);
	this.downDelay = LOGIN_SCROLLBUTTON_SCROLL_DELAY * 10;
end

function LoginScrollDownButton_OnUpdate(this, elapsed)
	if ( this:IsButtonPushed("LeftButton") and this.downDelay ) then
		this.downDelay = this.downDelay - elapsed;
		if ( this.downDelay < 0 ) then
			local slider = this:GetParent();
			local step = slider.stepRange or 1;
			slider:SetValue(slider:GetValue() + step);
			this.downDelay = LOGIN_SCROLLBUTTON_SCROLL_DELAY;
		end
	end
end

function LoginScrollBar_OnValueChanged(this, arg1)
	if ( this.scrollframe ) then
		this.scrollframe:SetVerticalScroll(arg1);
	else
		local value = this:GetValue();
		if ( (value - this:GetMinValue()) == 0 ) then
			getglobal(this:GetName().."ScrollUpButton"):Disable();
		else
			getglobal(this:GetName().."ScrollUpButton"):Enable();
		end
		if ( (value - this:GetMaxValue()) == 0 ) then
			getglobal(this:GetName().."ScrollDownButton"):Disable();
		else
			getglobal(this:GetName().."ScrollDownButton"):Enable();
		end
	end
end

function LoginScrollBar_OnMouseWheel(this, delta)
	if ( this.scrollframe ) then
		LoginScrollFrame_OnMouseWheel(this.scrollframe, delta);
	else
		if ( delta > 0 ) then
			this:SetValue(this:GetValue() - 1);
		else
			this:SetValue(this:GetValue() + 1);
		end
	end
end

function LoginScrollFrame_OnLoad(this)
	local scrollbar = getglobal(this:GetName().."ScrollBar");
	getglobal(scrollbar:GetName().."ScrollUpButton"):Disable();
	getglobal(scrollbar:GetName().."ScrollDownButton"):Disable();
	scrollbar:SetMinMaxValues(0, 0);
	scrollbar:SetValue(0);
	scrollbar.scrollframe = this;
	scrollbar.stepRange = scrollbar:GetHeight() / 4;
end
			
function LoginScrollFrame_OnScrollRangeChanged(this, scrollrange)
	local scrollbar = getglobal(this:GetName().."ScrollBar");
	if ( scrollbar ) then
		local value = scrollbar:GetValue();

		if ( value > scrollrange ) then
			value = scrollrange;
		end

		scrollbar:SetMinMaxValues(0, scrollrange);
		scrollbar:SetValue(value);
		if ( math.floor(scrollrange) == 0 ) then
			scrollbar:Hide();
			getglobal(scrollbar:GetName().."ScrollUpButton"):Disable();
			getglobal(scrollbar:GetName().."ScrollDownButton"):Disable();
		else
			scrollbar:Show();
			getglobal(scrollbar:GetName().."ScrollDownButton"):Enable();
		end
	end
end

function LoginScrollFrame_OnVerticalScroll(this, arg1)
	local scrollbar = getglobal(this:GetName().."ScrollBar");
	if ( scrollbar ) then
		local min, max;
		scrollbar:SetValue(arg1);
		min, max = scrollbar:GetMinMaxValues();
		if ( arg1 == 0 ) then
			getglobal(scrollbar:GetName().."ScrollUpButton"):Disable();
		else
			getglobal(scrollbar:GetName().."ScrollUpButton"):Enable();
		end
		if ((scrollbar:GetValue() - max) == 0) then
			getglobal(scrollbar:GetName().."ScrollDownButton"):Disable();
			if ( this.OnReadFinish ) then
				this.OnReadFinish();
			end
		else
			getglobal(scrollbar:GetName().."ScrollDownButton"):Enable();
		end
	end
end

function LoginScrollFrame_OnMouseWheel(this, delta)
	local scrollbar = getglobal(this:GetName().."ScrollBar");
	local scrollRange = scrollbar.stepRange or 1;
	if ( scrollbar ) then
		if ( delta > 0 ) then	
			scrollbar:SetValue(scrollbar:GetValue() - scrollRange);
		else
			scrollbar:SetValue(scrollbar:GetValue() + scrollRange);
		end
	end
end

