MAX_REALMS_DISPLAYED = 14;

function RealmList_OnLoad(this)
	--this:RegisterEvent("OPEN_REALM_LIST");
	this.selectedName = nil;
end

function RealmList_OnShow(this)
	this.selectedName = GetCurrentRealm();
	RealmLastSelectedButton:SetChecked(GetSelectedRealmState());
	RealmList_Update();
end

function RealmList_OnEvent(this, event)
	if ( event == "OPEN_REALM_LIST" ) then
		if ( this:IsVisible() ) then
			RealmList_Update();
		else
			this:Show();
		end
	end
end

function RealmList_Update()
	local maxNums = GetNumRealms() - MAX_REALMS_DISPLAYED;
	if ( maxNums > 0 ) then
		RealmListScrollBar:SetMinMaxValues(0, maxNums);
		RealmListScrollBar:Show();
	else
		RealmListScrollBar:SetMinMaxValues(0, 0);
		RealmListScrollBar:Hide();
	end

	RealmListUpdate();
end

function RealmListUpdate()
	local numRealms = GetNumRealms();
	local index = RealmListScrollBar:GetValue();
	local name, division;
	local button, divisionText, loadText;
	
	for i = 1, MAX_REALMS_DISPLAYED do
		button = getglobal("RealmListButton"..i);
		if ( i + index > numRealms ) then
			button:Hide();
		else
			divisionText = getglobal(button:GetName().."Division");
			loadText = getglobal(button:GetName().."Load");
			name, division, load = GetRealmInfo(i + index);

			if ( load > 0.6 ) then
				loadText:SetText(LOAD_TYPE3);
				loadText:SetColor(1, 0, 0);
			elseif ( load > 0.3 ) then
				loadText:SetText(LOAD_TYPE2);
				loadText:SetColor(1, 1, 0);
			else
				loadText:SetColor(0, 1, 0);
				loadText:SetText(LOAD_TYPE1);
			end
			
			if ( RealmList.selectedName == name ) then
				button:LockHighlight();
			else
				button:UnlockHighlight();
			end
			
			divisionText:SetText(division);
			button:SetText(name);
			button.name = name;
			button:Show();
		end
	end
	
	if ( RealmList.selectedName ) then
		RealmListOkButton:Enable();
	else
		RealmListOkButton:Disable();
	end
end

function RealmListButton_OnClick(this)
	RealmList.selectedName = this.name;
	RealmListUpdate();
	--RealmListOkButton:SetText(RealmList.selectedName) -- bÖrt
end

function RealmListButton_OnDoubleClick(this)
	RealmList.selectedName = this.name;
	RealmList_OnOk();
end

function RealmList_OnOk()
	RealmList:Hide();
	if ( RealmList.selectedName ) then
		ChangeRealm(RealmList.selectedName);
	end
end

function RealmList_OnCancel()
	RealmList:Hide();
	RealmList.selectedName = nil;
end
