--[[
/run for _, v in pairs({pcall(dofile, "Interface/Addons/vx2019_SlashCommand/vx2019_SlashCommand.lua")}) do print(tostring(v)) end
]]

SLASH_LOGOUT1 = "/logout"
SLASH_LOGOUT2 = "/camp"
SLASH_LOGOUT3 = "/vx"

local get_server_list = function()
	local list = {}
	local i = 0

	repeat
		i = i + 1
		local _, name, _, char_count = GetServerListInfo(i)
		if name and char_count and type(char_count) == "number" and char_count > 0 then
			list[name] = char_count
		end
	until 
		not name
		
	return list
end

SlashCmdList["LOGOUT"] = function(editBox, msg)
	if msg == "" then
		return nil
	end
	
	local camp_char, channel_number, server_name
	
	vx2019_AutoLogin_SwitchCharacter = nil
	vx2019_AutoLogin_SwitchChannel	 = nil
	vx2019_AutoLogin_SwitchServer	 = nil
	
	local args = {}
	
	for arg in msg:gmatch("%S+") do
		table.insert(args, tonumber(arg) or arg)
	end
	
	for k, v in pairs(args) do
		if (not channel_number) and (type(v) == "number") then
			channel_number = v
		end
		
		if camp_char and (not server_name) and (type(v) == "string") then
			server_name = v:lower():gsub("^%S", function(a) return a:upper() end)
		end
		
		if (not camp_char) and (type(v) == "string") then
			camp_char = v:lower()
		end
	end

	if camp_char then		
		local unit_name = UnitName("player")
		
		if unit_name then
			if (camp_char == unit_name:lower()) and ((not server_name) or (server_name == GetCurrentRealm())) then
				return nil
			end
		end
	else
		return nil
	end
	
	if (not camp_char) or camp_char == "" then
		return nil
	end
	

	local account_has_char = false
	
	for i = 1, MAX_CHARACTERS_PER_REALM do
		local obj = getglobal("CharacterSelectCharacterButton"..i.."ButtonTextName")
		
		if obj then
			local txt = obj:GetText()
			
			if txt and txt ~= ""  then
				if txt:lower() == camp_char then
					account_has_char = true
					break
				end
			end
		end
	end
	
	if not account_has_char then		
		if server_name and (server_name ~= GetCurrentRealm()) then		
			vx2019_AutoLogin_SwitchServer = server_name
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000'"..camp_char.."' is not on this server!|r")
			return nil
		end
	end
	
	if server_name and not (get_server_list())[server_name] then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000'"..server_name.."' is not a valid server!|r")
		return nil
	end
	
	vx2019_AutoLogin_SwitchCharacter = camp_char
	vx2019_AutoLogin_SwitchChannel 	 = math.min(channel_number or GetCurrentParallelID() or 1, GetNumParalleZones())
	Logout()
end